# include <stdio.h>
# include <malloc.h>
# include <string.h>
# include <ctype.h>

/* default resource file name */
#define	def_rcfile_name	".cgirc"

/* divides script name and variable name */
#define	def_divider	':'

#define	def_comment_sign	'#'

#define	def_block_opener	'{'
#define	def_block_closer	'}'

/* default buffer size for reading */
#define	def_bufsize		4096

struct	rcfield_struct
 {
	char*	name;
	char*	value;
	struct rcfield_struct *	next;
 } *rcfield;

int	load_rcfile( char* rcfile_name, char* cgi_type  )
 {
	FILE*	rcfile;
	char	buf[def_bufsize];
	char	prefix[def_bufsize];
	char*	p;
	char*	cp;

	char	tn[def_bufsize];
	char	tv[def_bufsize];
	char	block_name[def_bufsize];

	int	i;
	int	l;

	int	block_flag;

	struct rcfield_struct*	cur_field;
	struct rcfield_struct*	tmp_field;

	if ( (rcfile	=	fopen(rcfile_name,"r")) == NULL )
		return 1;

	rcfield		=	NULL;
	cur_field	=	rcfield;

	l	=	sprintf(prefix,"%s%c",cgi_type,def_divider);

	block_flag	=	0;

	while ( !feof(rcfile) )
		{
			if ( fgets(buf,def_bufsize,rcfile) == NULL )
			break;

			p	=	buf;

			/* remove comments up to the and of string */
			if ( (cp = strchr(p,def_comment_sign)) != NULL )
				*cp	=	0;

			if ( strchr(p,def_block_opener) != NULL )
				{
					block_flag	=	1;
					continue;
				}

			if ( strchr(p,def_block_closer) != NULL )
				{
					block_flag	=	0;
					continue;
				}

			/* check case cgi_type:variable value */
			if ( !strncmp(p,prefix,l) )
				p	+=	l;

			/* skip leading space */
			for ( i=0; i < strlen(p); i++ )
				{
					if ( !isspace(p[i]) )
						{
							p	+=	i;
							break;
						}
				}

			tn[0]	=	0;
			/* get name */
			for ( i=0; i < strlen(p); i++ )
				{
					if ( isspace(p[i]) )
						{
							strncpy(tn,p,i);
							tn[i]	=	0;
							p	+=	i;
							break;
						}
				}

			/* do we got a variable name? */
			if ( !strlen(tn) )
				continue;

			if ( !block_flag )
				strcpy(block_name,tn);

			tv[0]	=	0;
			/* get value */
			p[strlen(p)-1]	=	0;
			for ( i=0; i < strlen(p); i++ )
				{
					if ( !isspace(p[i]) )
						{
							p	+=	i;
							strcpy(tv,p);
							break;
						}
				}

			for ( i=strlen(tv)-1; i >= 0 ; i-- )
				if ( !isspace(tv[i]) )
					{
						tv[i+1]	=	0;
						break;
					}


			/* do we got a variable value? */
			if ( !strlen(tv) )
				continue;

			tmp_field = (struct rcfield_struct *)malloc(sizeof(struct rcfield_struct));
			if ( block_flag && strcmp(block_name,cgi_type) )
				{
					char t[def_bufsize];
					sprintf(t,"%s%c%s",block_name,def_divider,tn);
					strcpy(tn,t);
				}
			tmp_field->name	=	strdup(tn);
			tmp_field->value	=	strdup(tv);
			tmp_field->next	=	NULL;
/*			printf("%s\t\"%s\"\n",tmp_field->name,tmp_field->value);*/

			if ( cur_field == NULL )
				rcfield	=	tmp_field;
					else
						cur_field->next	=	tmp_field;
			cur_field	=	tmp_field;
		}
	fclose(rcfile);
	return 0;
 }

char*	get_value( char* name )
 {
	struct rcfield_struct*	p	=	rcfield;
	while ( p != NULL )
		if ( strcmp(p->name,name) )
			p	=	p->next;
				else
					return p->value;
	return NULL;
 }
