/***************************************************************************/
/*                                                                         */
/*                                                                         */
/***************************************************************************/

# include "mylib.h"

/***************************************************************************/
void  *Calloc( long N, long S )
{  void *v ;
   if( N*S <0 ) return NULL ;
   v=calloc( N,S );
   if( v==NULL ) throw(-1);
   return v ;
}
/***************************************************************************/
void  *Malloc( long N, long S )
{  void *v ;
   if( N*S <0 ) return NULL ;
   v=malloc( N*S );
   if( v==NULL ) throw(-1);
   return v ;
}
/***************************************************************************/
void  *Realloc( void *M, long L )
{  void *v ;
   if( L <0 ) return NULL ;
   v=realloc( M,L );
   if( v==NULL ) throw(-1);
   return v ;
}
/***************************************************************************/
FILE  *Fopen( char *Name, char *a )
{  FILE *f ;
   f=fopen( Name, a );
   if( f==NULL ) throw(-1);
   return f ;
}
/***************************************************************************/
void   Fread( void *M, long S, long N, FILE *File )
{  long n ;
   n=fread( M, S, N, File );
   if( n!=N ) throw(-1);
}
/***************************************************************************/
void   Fwrite( void *M, long S, long N, FILE *File )
{  long n ;
   n=fwrite( M, S, N, File );
   if( n!=N ) throw(-1);
}
/***************************************************************************/
void   Fseek( FILE *fw, long Offset, long Mode )
{
   if( 0!=fseek( fw, Offset, Mode ) )throw(-1);
}
/***************************************************************************/
long   FileLength( FILE *fw )
{
   long Cur,L ;

   if( 0!=fgetpos( fw,&Cur ) ) throw( -1 );
   if( 0!=fseek( fw,0L,SEEK_END) ) throw( -1 );
   if( 0!=fgetpos( fw,&L ) ) throw( -1 );
   if( 0!=fseek( fw,Cur,SEEK_SET) ) throw( -1 );
   return L ;
}

#if defined(__QNX__)
const char koi8r[] = "";
const char cp866[] = "";

/******************************/
void koi8tocp866( char *s )
{
	int i=0;
	int index;

	if( !s || !strlen( s )) return;

	for( ; i<strlen( s ); i++ )
	{
		if( s[i] < 128 )
			continue;
		for( index=0; 
			index < sizeof( koi8r ) /*|| s[i] == koi8r[index]*/;
			index ++ )
		{
			if( s[i] == koi8r[index] )
				break;
		}
		s[i] = (index == sizeof( koi8r ) ? '?': cp866[index]);
	}
}
#endif
