/****************************************************************************
   This is a part of programm of Dictionary for UNIX
   Copyright (C) 1999 Anisimow Dmitry.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
****************************************************************************/

# include <stdio.h>
# include <malloc.h>
# include <string.h>
# include <dirent.h>
# include <sys/types.h>
# include <sys/stat.h>
# include <stdlib.h>

# include "mylib.h"
# include "slowo.h"

# define min(a,b) (((a)<(b)) ? (a) : (b))
# define max(a,b) (((a)>(b)) ? (a) : (b))
# define uchar unsigned char

char  **Files ;
short   n_Files ;
uchar   SC[256] ;
char    StrWord[40],StrTrans[40],StrAnswer[1000] ;

//char    StartPath[200];
# define  is_divider(SS)  (0==strncmp( SS,Divider,l_Divider ))

void  main_loop( void );
void  malen( short i_wort,char *Str );
void  antwort( long i_wort );
void  malen1( long i_wort, short x, short y );
short my_strncmp( char *Str1, char *Str2, short L );
void  SC_init( void );

/***************************************************************************/

/***************************************************************************/
char schablon( char *Str )
{
   short l=strlen( Str );
   return strcmp( Str+l-4,".dwa" );
}
/* ----------------------------------------------------------------------- */
void init_buch( char *StartPath )
{
   DIR *my_dir ;
   struct dirent *ent ;
   static struct stat stat1 ;
   long   j;
   char   path[200]=".",path1[200] ;

   if( StartPath[0]!=0 ) strcpy( path,StartPath );
   my_dir = opendir( path );
   if( my_dir==NULL )
   {  printf("\n File of dictionary NOT found!"); exit(-1);  }
   Files=(char **)Calloc( 18,sizeof(char *) );

   j=0 ;
   while( (ent = readdir( my_dir )) != NULL )
   {
// ram's code
//      ent = readdir( my_dir ) ;
//      if( ent == NULL ) break ;

		strcpy(path1,path); 
		strcat(path1,"/"); 
		strcat(path1,ent->d_name);
		stat( path1,&stat1 ) ;
		if( !S_ISDIR( ent->d_stat.st_mode ))
		{  
			if( 0!=schablon( ent->d_name) ) 
				continue ;
			Files[j]=(char *)Calloc( strlen(ent->d_name)+1,sizeof(char) );
			strcpy( Files[j],ent->d_name );
			if( 18<=j++ ) 
				break ;
		}
	}
	closedir( my_dir ) ;
	n_Files=j ;
	if( j==0 )
	{  
		printf("\n File of dictionary NOT found!"); 
		exit(-1);  
	}
}
/***************************************************************************/
t_WorterBuch :: t_WorterBuch( void )
{
   sy_Word    = NULL ;
   f_disk     = 0 ;
   Paragraf   = NULL ;
   n_sy_Word  = 0 ;
   n_Paragraf = 0 ;
   NameFile[0]= 0 ;
   i_Paragraf =-1 ;
   Buf        = NULL ;
   l_Buf      = 0;
   strcpy( Divider,"=" );
   l_Divider=strlen( Divider );
}
/***************************************************************************/
void t_WorterBuch :: make( char *File )
{  
	FILE   *fr ;
	size_t  k ;
	long    i,i1,ii,j,j1 ;
	char    f1=0,f2=0 ;
	char    *m,Name[200] ;

	SC_init();

	fr=Fopen( File,"rb" );

	if( Buf     !=NULL ) free(Buf);
	if( sy_Word !=NULL ) free(sy_Word);
	if( Paragraf!=NULL ) free(Paragraf);

	Buf = m = (char *)Calloc( 4000,sizeof(char) );
	n_sy_Word=1 ;
	while( 1 )
	{  
		k=fread( m,1,2000,fr );
		for( i=0 ; i<k ; i++ )
		if( m[i]=='\n' ) n_sy_Word++ ;
		if( k<2000 ) break ;
	}
	fseek( fr,0,SEEK_SET );

	sy_Word =(long       *)Calloc( n_sy_Word     ,sizeof(long) );
	Paragraf=(t_Paragraf *)Calloc( n_sy_Word/16+2,sizeof(t_Paragraf) );

	ii = j = 0 ;
	while( 1 )
	{
		k=fread( m,1,2000,fr );
		for( i=0 ; i<k ; i++ )
		{   
			i1=ii+i ;
			if( m[i]=='\n' || m[i]=='\r' ) 
			{ 
				f1=1 ; 
				f2=0 ; 
				j1=0 ; 
			}
			if( f1==1 && m[i]!='\n' && 
				m[i]!='\r' && m[i]!='\t' && 
				m[i]!=' ' )
			{  
				sy_Word[++j]=i1 ; 
				f1=0 ; 
				f2=1 ; 
			}
			if( (j&0x0f)==0 && f2==1 && j1<8 )
			{   
				Paragraf[j/16].word[ j1++ ]=m[i] ;
				if( m[i]=='\n' || m[i]=='\r' || m[i]=='\t' || m[i]==' ' || 
					is_divider( m+i ) )
				{   
					f2=0 ;
					Paragraf[j/16+1].word[ j1++ ]=0 ;  
				}
			}
		}
		if( k<2000 ) 
			break ;
		ii+=k ;
	}
	i_wort=0 ;
	n_sy_Word=j ;
	n_Paragraf=j/16+1 ;

	fclose( fr );

	strcpy( NameFile,File );
	for( k=0, i=48 ; i<n_sy_Word ; i+=16 )
		k=max( k,sy_Word[i]-sy_Word[i-48] );
	if( k>4000 )
	{
		free(Buf); 
		Buf =(char *)Calloc( k,sizeof(char) );  
	}
}
/***************************************************************************/
long t_WorterBuch :: find( char *_Str )
{  long b,e,i,i1,i2,L ;
   long w,i_Save,i_Ret=-1 ;
   char Str2[80] ;

   b=0 ; e=n_Paragraf ;
   i_Save=i_Paragraf ;
   while( 1 )
   {  if( e-b<=1 ) break ;
      i=(b+e)/2 ;
      if( 0<my_strncmp( _Str,Paragraf[i].word,8 ) ) b=i ; else e=i ;
   }
   w=(i-1)*16 ;
   read_paragraf( w );

   // -------------  筮 ⠪ ப ---------------
   L=strlen(_Str);
   for( i1=0 ; i1<48 ; i1++ )
   {
       if( n_sy_Word<=w+i1 ) continue ;
       strncpy( Str2,Buf+sy_Word[w+i1]-sy_Word[w],80 ); Str2[79]=0 ;
       for( i2=0 ; i2<79 ; i2++ )
	  if( is_divider( Str2+i2 ) ) Str2[i2]=0 ;
       if( 0==my_strncmp( Str2,_Str,L ) )
       {  i_Ret=w+i1 ; goto M_Ok ;  }
   }
   // --- ᫨   筮 ⠪ ப,  宦 ----
   for( i=L-1 ; 0<i ; i-- )
   {  for( i1=0 ; i1<48 ; i1++ )
      {
	  if( n_sy_Word<=w+i1 ) continue ;
	  strncpy( Str2,Buf+sy_Word[w+i1]-sy_Word[w],80 ); Str2[79]=0 ;
	  for( i2=0 ; i2<79 ; i2++ )
	     if( is_divider( Str2+i2 ) ) Str2[i2]=0 ;
	  if( 0==my_strncmp( Str2,_Str,i ) )
	  {  i_Ret=w+i1 ; goto M_Ok ;  }
      }
   }

   read_paragraf( i_Save*16 );
M_Ok:
   return i_Ret ;
}
/***************************************************************************/
void t_WorterBuch :: read_paragraf( long i_Wort )
{
	long  i,p,l ;
	FILE *fr ;

	i=i_Wort/16 ;
	p=sy_Word[i*16] ;
	if( i*16+48<n_sy_Word ) 
		l=sy_Word[i*16+48]-p ;
	else
		l=sy_Word[n_sy_Word]-p ;
	i_Paragraf=i ;

	fr=Fopen( NameFile,"rb" );
	fseek( fr,p,SEEK_SET );
	fread( Buf,1,l,fr );
	fclose( fr );

#ifdef __QNX__
	koi8tocp866( Buf );
#endif

}
/***************************************************************************/
char * t_WorterBuch :: wort( long i )
{  long i1,i2,off,FirstWord ;

   FirstWord=i_Paragraf*16 ;

   if( i<0 || n_sy_Word<i )
   {  StrWord[0]=0 ;  }
   else
   {
      off = sy_Word[i] - sy_Word[FirstWord] ;
      strncpy( StrWord,Buf+off,40 ); StrWord[39]=0 ;
      for( i1=0 ; i1<40 ; i1++ )
	 if( is_divider( StrWord+i1 ) ) StrWord[i1]=0 ;
   }
   return StrWord ;
}
/***************************************************************************/
char * t_WorterBuch :: trans( long i_wort )
{  long  i,j,off,end,B,L ;
   char  *Str ;

   if( i_wort<0 || n_sy_Word<i_wort )
   {  StrTrans[0]=0 ;  }
   else
   {
      read_paragraf( i_wort );
      B=sy_Word[i_Paragraf*16] ;
      off = sy_Word[i_wort] - B ;
      end = sy_Word[i_wort+1] - B ;
      L=min( 1000,end-off );
      Str=Buf+off ;

      for( i=0 ; i<L ; i++ )
	 if( Str[i]=='[' ) break ;
      for( j=0 ; i<L && j<40 ; i++ )
      {  StrTrans[j++]=Str[i] ;
	 if( Str[i]==']' ) break ;
      }
   }
   StrTrans[j]=0 ;
   return StrTrans ;
}
/***************************************************************************/
char * t_WorterBuch :: answer( long i_wort )
{  long  i,j,off,end,B,L ;
   char  f ;
   char  *Str ;

   if( i_wort<0 || n_sy_Word<i_wort )
   {  StrTrans[0]=0 ;  }
   else
   {
      read_paragraf( i_wort );      
      B=sy_Word[i_Paragraf*16] ;
      off = sy_Word[i_wort] - B ;
      end = sy_Word[i_wort+1] - B ;
      L=min( 1000,end-off );
      Str=Buf+off ;

      for( i=j=0,f=0 ; i<L ; i++ )
      {  if( Str[i]=='[' ) f=1 ;
	 if( Str[i]==']' ) { f=0 ; continue ; }
	 if( f==1 ) continue ;
	 if( Str[i]==';' ) StrAnswer[j++]='\n' ;
	     else          StrAnswer[j++]=Str[i] ;
      }
      StrAnswer[j]=0 ;
   }
   return StrAnswer ;
}
/***************************************************************************/
void t_WorterBuch :: set_divider( char * _Divider )
{
   short  i,j ;
   char  *c ;

   c=Divider ;
   strcpy( c,_Divider );
   for( i=j=0 ; i<10 ; i++ )
   {  if( c[i]!='"' ) c[j++]=c[i] ;
      if( c[i]==0 ) break ;
   }	
   l_Divider=strlen( Divider ) ;
}   
/***************************************************************************/
short my_strncmp( char *Str1, char *Str2, short L )
{  short i,c ;

   for( i=0 ; i<L ; i++ )
   {  if( Str1[i]==0 && Str2[i]!=0 ) return -1 ;
      if( Str2[i]==0 && Str1[i]!=0 ) return  1 ;
      c = SC[(uchar)Str1[i]] - SC[(uchar)Str2[i]] ;
      if( c!=0 ) return c ;
   }
   return 0 ;
}
/***************************************************************************/
void SC_init( void )
{  short i ;

   for( i=0 ; i<256 ; i++ )
      SC[i]=i ;

   for( i=65 ; i<91 ; i++ )
      SC[i]=i+32 ;

   SC[193]=SC[225]=128 ;
   SC[194]=SC[226]=129 ;
   SC[215]=SC[247]=130 ;
   SC[199]=SC[231]=131 ;
   SC[196]=SC[228]=132 ;
   SC[197]=SC[229]=133 ;
   SC[214]=SC[246]=134 ;
   SC[218]=SC[250]=135 ;
   SC[201]=SC[233]=136 ;
   SC[202]=SC[234]=137 ;
   SC[203]=SC[235]=138 ;
   SC[204]=SC[236]=139 ;
   SC[205]=SC[237]=140 ;
   SC[206]=SC[238]=141 ;
   SC[207]=SC[239]=142 ;
   SC[208]=SC[240]=143 ;
   SC[210]=SC[242]=144 ;
   SC[211]=SC[243]=145 ;
   SC[212]=SC[244]=146 ;
   SC[213]=SC[245]=147 ;
   SC[198]=SC[230]=148 ;
   SC[200]=SC[232]=149 ;
   SC[195]=SC[227]=150 ;
   SC[222]=SC[254]=151 ;
   SC[219]=SC[251]=152 ;
   SC[221]=SC[253]=153 ;
   SC[216]=SC[248]=154 ;
   SC[217]=SC[249]=155 ;
   SC[223]=SC[255]=156 ;
   SC[220]=SC[252]=157 ;
   SC[192]=SC[224]=158 ;
   SC[209]=SC[241]=160 ;
}
